//вывод фотокартинок с помощью сенсора -КНОПКИ
#include <Adafruit_GFX.h>
#include <Adafruit_ILI9341.h>
#include <XPT2046_Touchscreen.h>// Библиотека для работы с сенсорным экраном
#include <SPI.h>
#include "ris_.h"//файл хранения массивов фотокартинок
#define TFT_CS     17
#define TFT_DC     20
#define CS_PIN  14
//#define TFT_RST -1            // Пин подключения вывода RESET (ПРИ -1 СОЕДИНЯЕМ С +3,3В)
//#define TFT_MISO 16           // Пин подключения вывода дисплея SDO(MISO)
//#define TFT_MOSI 19           // Пин подключения вывода дисплея SDI(MOSI)
//#define TFT_CLK 18            // Пин подключения вывода дисплея SCK
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS,  TFT_DC);//
XPT2046_Touchscreen ts(CS_PIN);  // Param 2 - NULL - No interrupts

byte fl[12]={1,1,1,1,1,1,1,1,1,1,1,1};//массив флажков состояния кнопок
 int x, y;                         // Переменные для работы с координатами нажатий
long Y1=0;//переменная хранения моментов времени
bool FLAG=false;
 
void setup() {
pinMode(4,INPUT);//вывод проверяющий уровень на выходе state HC05
  
Serial1.setRX(1);
Serial1.setTX(0); 
Serial1.begin(19200); 
 
  tft.begin();
  tft.setRotation(2);
 tft.fillScreen(tft.color565(0,0,0)); 

  ts.begin();
  ts.setRotation(2);
 drawFoto(0,0,ris_01,240,320);//исходная картинка кнопок
 
  }
void loop() {
 //
 if(digitalRead(4)==HIGH&&fl[1]==1){fl[1]=2;drawFoto_fragment(0,0,ris_02,240,320,0,0,240,80);}//условия установления соединения связи с танком 
 if(digitalRead(4)==LOW&&fl[1]==2){fl[1]=1;drawFoto_fragment(0,0,ris_01,240,320,0,0,240,80);}
 // 
  if(ts.touched()&&!FLAG) { // Если имеются данные с сенсорного модуля
 TS_Point p = ts.getPoint();                      // Считываем с него данные
    y = map(p.y,220,3720,0,319);                  // Считываем и преобразуем координату нажатия X
    x =map(p.x,275,3830,0,240);                   // Считываем и преобразуем  координату нажатия Y           
    if((x!=-1) && (y!=-1))          // Если обе координаты в положительном диапазоне (т.е. если есть нажатие) 
     {
      x += 0;                      // Корректируем координату с учетом калибровочных данных
      y += 0;                       // Корректируем координату с учетом калибровочных данных
  dinamika();FLAG=true;   
     }
  }
// 
if(!ts.touched()&&FLAG){FLAG=false;Serial1.print("5");Serial1.print('\n');drawFoto_fragment(0,80,ris_01,240,320,0,80,240,240);for(int i=3;i<12;i++){fl[i]=1;}}//сброс всех кнопок кроме верхних 3, если сенсор отпущен
}
/////////////////////////////////////////////////////////////////
void drawFoto(uint16_t x,uint16_t y, const uint8_t *bitmap,uint16_t w,uint16_t h) {//функция вывода фотокартинки
if(x<0||x+w>240||y<0||y+h>320){return;} 
// tft.setAddrWindow(x,y,w,h);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW);
  tft.setAddrWindow(x,y,w,h); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
///////////////////////////////////////////////////////////////
//функция вывода фрагмента фотокартинки размером w*h,x,y - положение фрагмента на экране, x1,y1,w1,h1 - выбор фрагмента из массива
void drawFoto_fragment(int x,int y, const uint8_t *bitmap,int w,int h,int x1,int y1,int w1,int h1) {
if(x<0||x+w1>240||y<0||y+h1>320){return;} 
// tft.setAddrWindow(x,y,w1,h1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW);
  tft.setAddrWindow(x,y,w1,h1); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
      if(i>=2*x1&&i<2*(x1+w1)&&j>=y1&&j<y1+h1){
       SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
      }  
   }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 //  
}
////////////////////////////////////////////////////////////////////
void dinamika(){
   if(x>0&&x<80&&y>0&&y<80){
//fl[0]=2;drawFoto_fragment(0,0,ris_02,240,320,0,0,80,80);//
 }
   if(x>80&&x<160&&y>0&&y<80){
//fl[1]=2;drawFoto_fragment(80,0,ris_02,240,320,80,0,80,80);
 }
   if(x>160&&x<240&&y>0&&y<80){
//fl[2]=2;drawFoto_fragment(160,0,ris_02,240,320,160,0,80,80);
 }
  if(x>0&&x<80&&y>80&&y<160){
fl[3]=2;drawFoto_fragment(0,80,ris_02,240,320,0,80,80,80);
Serial1.print("4");Serial1.print('\n');
 }
   if(x>80&&x<160&&y>80&&y<160){
fl[4]=2;drawFoto_fragment(80,80,ris_02,240,320,80,80,80,80);
Serial1.print("1");Serial1.print('\n');
 }
   if(x>160&&x<240&&y>80&&y<160){
fl[5]=2;drawFoto_fragment(160,80,ris_02,240,320,160,80,80,80);
Serial1.print("3");Serial1.print('\n');
   }
  if(x>0&&x<80&&y>160&&y<240){
fl[6]=2;drawFoto_fragment(0,160,ris_02,240,320,0,160,80,80);
Serial1.print("9");Serial1.print('\n');
  }
   if(x>80&&x<160&&y>160&&y<240){
//fl[7]=2;drawFoto_fragment(80,160,ris_02,240,320,80,160,80,80);
  }
   if(x>160&&x<240&&y>160&&y<240){
fl[8]=2;drawFoto_fragment(160,160,ris_02,240,320,160,160,80,80);
Serial1.print("6");Serial1.print('\n');
   }
 if(x>0&&x<80&&y>240&&y<320){
fl[9]=2;drawFoto_fragment(0,240,ris_02,240,320,0,240,80,80);
Serial1.print("7");Serial1.print('\n');
 }
   if(x>80&&x<160&&y>240&&y<320){
fl[10]=2;drawFoto_fragment(80,240,ris_02,240,320,80,240,80,80);
Serial1.print("2");Serial1.print('\n');
   }
   if(x>160&&x<240&&y>240&&y<320){
fl[11]=2;drawFoto_fragment(160,240,ris_02,240,320,160,240,80,80);
Serial1.print("8");Serial1.print('\n');
   }
 
}
////////////////////////////////////////////////////////////////////

